oracle.pgx.api.admin

## Interface Control

- All Known Implementing Classes:
    AbstractControl

      public interface Control

  Encapsulates all administrative functions of PGX

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `PGX_CONFIG_FILE_SYSTEM_PROPERTY`
    `static String` | `SERVER_CONFIG_FILE_NAME`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PgxFuture<Void>` | `addPinnedGraph(GraphConfig cfg)` Add a pinned graph (will not be unloaded by engine) to be shared between sessions
    `PgxFuture<Void>` | `demotePinnedGraph(GraphConfig cfg)` Demote pinned graph.
    `PgxFuture<GraphInfo>` | `getGraphInfo(String graphName)` Get details of a (shared) persistent graph
    `PgxFuture<GraphInfo>` | `getGraphInfo(String sessionId, String graphName)` Get details of a session-bound, private graph
    `PgxFuture<Collection<GraphInfo>>` | `getGraphInfos()` Get a list of currently active graphs.
    `PgxFuture<MemoryInfo>` | `getMemoryInfo()` Gets the memory info.
    `PgxFuture<Map<PgxConfig.Field,Object>>` | `getPgxConfig()` Gets the pgx config.
    `PgxFuture<SessionInfo>` | `getSessionInfo(String sessionId)` Gets the session info.
    `PgxFuture<Collection<SessionInfo>>` | `getSessionInfos()` Gets the session infos.
    `PgxFuture<PoolInfo>` | `getThreadPoolInfo(PoolType type)` Gets the thread pool info.
    `PgxFuture<Boolean>` | `isRunning()` Check if the engine is currently up
    `PgxFuture<Void>` | `killSession(String sessionId)` Kill session.
    `PgxFuture<GraphConfig>` | `lookupPreloadedGraph(String name)` look up the config of a pre-loaded graph by name.
    `PgxFuture<Void>` | `resizePool(PoolType poolType, int parallelism)` resize a pool to use a different degree of parallelism
    `PgxFuture<Boolean>` | `shutdown(long timeout, TimeUnit unit)` gracefully shuts down the engine and cleans up resources.
    `PgxFuture<Void>` | `shutdownNow()` forces the engine to stop and clean up resources.
    `PgxFuture<Void>` | `shutdownNowIfRunning()`
    `PgxFuture<Void>` | `start()`
    `PgxFuture<Void>` | `start(InputStream config)`
    `PgxFuture<Void>` | `start(Map<PgxConfig.Field,Object> config)`
    `PgxFuture<Void>` | `start(String json)`

- - ### Field Detail

    - #### PGX_CONFIG_FILE_SYSTEM_PROPERTY

          static final String PGX_CONFIG_FILE_SYSTEM_PROPERTY

      See Also:
        Constant Field Values

    - #### SERVER_CONFIG_FILE_NAME

          static final String SERVER_CONFIG_FILE_NAME

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### addPinnedGraph

          PgxFuture<Void> addPinnedGraph(GraphConfig cfg)

      Add a pinned graph (will not be unloaded by engine) to be shared between sessions
      Parameters:
        `cfg` -

    - #### demotePinnedGraph

          PgxFuture<Void> demotePinnedGraph(GraphConfig cfg)

      Demote pinned graph.
      Parameters:
        `cfg` - the cfg

    - #### getGraphInfo

          PgxFuture<GraphInfo> getGraphInfo(String graphName)

      Get details of a (shared) persistent graph
      Parameters:
        `graphName` - internal name of persistent graph
      Returns:
        details of one specific graph

    - #### getGraphInfo

          PgxFuture<GraphInfo> getGraphInfo(String sessionId,
                                          String graphName)

      Get details of a session-bound, private graph
      Parameters:
        `sessionId` - session id of session holding the graph
        `graphName` - name of graph
      Returns:
        details of one specific graph

    - #### getGraphInfos

          PgxFuture<Collection<GraphInfo>> getGraphInfos()

      Get a list of currently active graphs.
      Returns:
        a list of currently active graphs

    - #### getMemoryInfo

          PgxFuture<MemoryInfo> getMemoryInfo()

      Gets the memory info.
      Returns:
        current memory usage statistics

    - #### getPgxConfig

          PgxFuture<Map<PgxConfig.Field,Object>> getPgxConfig()

      Gets the pgx config.
      Returns:
        current PGX server configuration as JSON string

    - #### getSessionInfo

          PgxFuture<SessionInfo> getSessionInfo(String sessionId)

      Gets the session info.
      Parameters:
        `sessionId` - the session id
      Returns:
        details of one specific session

    - #### getSessionInfos

          PgxFuture<Collection<SessionInfo>> getSessionInfos()

      Gets the session infos.
      Returns:
        a list of currently active sessions

    - #### getThreadPoolInfo

          PgxFuture<PoolInfo> getThreadPoolInfo(PoolType type)

      Gets the thread pool info.
      Parameters:
        `type` - which thread pool
      Returns:
        thread pool statistics

    - #### isRunning

          PgxFuture<Boolean> isRunning()

      Check if the engine is currently up
      Returns:
        true if engine is currently running, false otherwise

    - #### killSession

          PgxFuture<Void> killSession(String sessionId)

      Kill session.
      Parameters:
        `sessionId` - the session to be killed

    - #### lookupPreloadedGraph

          PgxFuture<GraphConfig> lookupPreloadedGraph(String name)

      look up the config of a pre-loaded graph by name.
      Parameters:
        `name` - the name of the graph
      Returns:
        the graph config of the pre-loaded graph, `null` if no such graph was pre-loaded.

    - #### resizePool

          PgxFuture<Void> resizePool(PoolType poolType,
                                   int parallelism)

      resize a pool to use a different degree of parallelism
      Parameters:
        `poolType` - which pool to resize
        `parallelism` - the target parallelism

    - #### shutdown

          PgxFuture<Boolean> shutdown(long timeout,
                                    TimeUnit unit)

      gracefully shuts down the engine and cleans up resources. All currently enqueued tasks will be worked off prior shut down, new incoming requests get rejected. This call blocks until shut down is complete or timed out.
      Returns:
        true if gracefully shut down. false if timed out before shut down.

    - #### shutdownNow

          PgxFuture<Void> shutdownNow()

      forces the engine to stop and clean up resources. Currently running tasks are interrupted. New incoming requests get rejected.
      Throws an exception when current tasks didn't finish after a short grace period.

    - #### shutdownNowIfRunning

          PgxFuture<Void> shutdownNowIfRunning()

    - #### start

          PgxFuture<Void> start()

    - #### start

          PgxFuture<Void> start(InputStream config)

    - #### start

          PgxFuture<Void> start(Map<PgxConfig.Field,Object> config)

    - #### start

          PgxFuture<Void> start(String json)

Copyright © 2015. All rights reserved.